<html>
<head>
<title>OgreControllerManager.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreControllerManager.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreControllerManager_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __ControllerManager_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __ControllerManager_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreCommon_8h.html">OgreCommon.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreSingleton_8h.html">OgreSingleton.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreController_8h.html">OgreController.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgrePredefinedControllers_8h.html">OgrePredefinedControllers.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="OgreTextureUnitState_8h.html">OgreTextureUnitState.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="OgreSharedPtr_8h.html">OgreSharedPtr.h</a>&quot;</span>
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="keyword">namespace </span>Ogre {
<a name="l00048"></a><a class="code" href="group__General.html#ga57d5b9493ba9c9b89479f942f237a37c">00048</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr&lt; ControllerValue&lt;Real&gt;</a> &gt; <a class="code" href="group__General.html#ga57d5b9493ba9c9b89479f942f237a37c">ControllerValueRealPtr</a>;
<a name="l00049"></a><a class="code" href="group__General.html#gafa8597a66f145eabb45e932f28fbb0b8">00049</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr&lt; ControllerFunction&lt;Real&gt;</a> &gt; <a class="code" href="group__General.html#gafa8597a66f145eabb45e932f28fbb0b8">ControllerFunctionRealPtr</a>;
<a name="l00050"></a>00050 
<a name="l00057"></a><a class="code" href="classOgre_1_1ControllerManager.html">00057</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ControllerManager.html" title="Class for managing Controller instances.">ControllerManager</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a>&lt;ControllerManager&gt;, <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">ControllerAlloc</a>
<a name="l00058"></a>00058     {
<a name="l00059"></a>00059     <span class="keyword">protected</span>:
<a name="l00060"></a><a class="code" href="classOgre_1_1ControllerManager.html#a096c21cea840f52ad6cbdbc60c47815b">00060</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1set.html">set&lt;Controller&lt;Real&gt;</a>*&gt;::type <a class="code" href="classOgre_1_1ControllerManager.html#a096c21cea840f52ad6cbdbc60c47815b">ControllerList</a>;
<a name="l00061"></a><a class="code" href="classOgre_1_1ControllerManager.html#ad263be2e0db9bbddc6e4587a78f615c8">00061</a>         <a class="code" href="classOgre_1_1ControllerManager.html#a096c21cea840f52ad6cbdbc60c47815b">ControllerList</a> <a class="code" href="classOgre_1_1ControllerManager.html#ad263be2e0db9bbddc6e4587a78f615c8">mControllers</a>;
<a name="l00062"></a>00062 
<a name="l00064"></a><a class="code" href="classOgre_1_1ControllerManager.html#a555188386569bbacdec2d662b64fd59c">00064</a>         <a class="code" href="classOgre_1_1SharedPtr.html">ControllerValueRealPtr</a> <a class="code" href="classOgre_1_1ControllerManager.html#a555188386569bbacdec2d662b64fd59c" title="Global predefined controller.">mFrameTimeController</a>;
<a name="l00065"></a>00065         
<a name="l00067"></a><a class="code" href="classOgre_1_1ControllerManager.html#ae275d3c92f688de92071a85e24a3f42f">00067</a>         <a class="code" href="classOgre_1_1SharedPtr.html">ControllerFunctionRealPtr</a> <a class="code" href="classOgre_1_1ControllerManager.html#ae275d3c92f688de92071a85e24a3f42f" title="Global predefined controller.">mPassthroughFunction</a>;
<a name="l00068"></a>00068 
<a name="l00069"></a>00069         <span class="comment">// Last frame number updated</span>
<a name="l00070"></a><a class="code" href="classOgre_1_1ControllerManager.html#a630fae68555eb16ed10c282fa5826eb8">00070</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="classOgre_1_1ControllerManager.html#a630fae68555eb16ed10c282fa5826eb8">mLastFrameNumber</a>;
<a name="l00071"></a>00071 
<a name="l00072"></a>00072     <span class="keyword">public</span>:
<a name="l00073"></a>00073         <a class="code" href="classOgre_1_1ControllerManager.html" title="Class for managing Controller instances.">ControllerManager</a>();
<a name="l00074"></a>00074         ~<a class="code" href="classOgre_1_1ControllerManager.html" title="Class for managing Controller instances.">ControllerManager</a>();
<a name="l00075"></a>00075 
<a name="l00078"></a>00078         <a class="code" href="classOgre_1_1Controller.html">Controller&lt;Real&gt;</a>* createController(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">ControllerValueRealPtr</a>&amp; src,
<a name="l00079"></a>00079             <span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">ControllerValueRealPtr</a>&amp; dest, <span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">ControllerFunctionRealPtr</a>&amp; func);
<a name="l00080"></a>00080 
<a name="l00083"></a>00083         <a class="code" href="classOgre_1_1Controller.html">Controller&lt;Real&gt;</a>* createFrameTimePassthroughController(
<a name="l00084"></a>00084             <span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">ControllerValueRealPtr</a>&amp; dest);
<a name="l00085"></a>00085 
<a name="l00088"></a>00088         <span class="keywordtype">void</span> clearControllers(<span class="keywordtype">void</span>);
<a name="l00089"></a>00089 
<a name="l00092"></a>00092         <span class="keywordtype">void</span> updateAllControllers(<span class="keywordtype">void</span>);
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 
<a name="l00104"></a>00104         <span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">ControllerValueRealPtr</a>&amp; getFrameTimeSource(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00105"></a>00105 
<a name="l00107"></a>00107         <span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">ControllerFunctionRealPtr</a>&amp; getPassthroughControllerFunction(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00108"></a>00108 
<a name="l00118"></a>00118         <a class="code" href="classOgre_1_1Controller.html">Controller&lt;Real&gt;</a>* createTextureAnimator(<a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique, of a Material.">TextureUnitState</a>* layer, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> sequenceTime);
<a name="l00119"></a>00119 
<a name="l00132"></a>00132         <a class="code" href="classOgre_1_1Controller.html">Controller&lt;Real&gt;</a>* createTextureUVScroller(<a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique, of a Material.">TextureUnitState</a>* layer, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> speed);
<a name="l00133"></a>00133 
<a name="l00144"></a>00144         <a class="code" href="classOgre_1_1Controller.html">Controller&lt;Real&gt;</a>* createTextureUScroller(<a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique, of a Material.">TextureUnitState</a>* layer, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> uSpeed);
<a name="l00145"></a>00145 
<a name="l00156"></a>00156         <a class="code" href="classOgre_1_1Controller.html">Controller&lt;Real&gt;</a>* createTextureVScroller(<a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique, of a Material.">TextureUnitState</a>* layer, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> vSpeed);
<a name="l00157"></a>00157 
<a name="l00168"></a>00168         <a class="code" href="classOgre_1_1Controller.html">Controller&lt;Real&gt;</a>* createTextureRotater(<a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique, of a Material.">TextureUnitState</a>* layer, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> speed);
<a name="l00169"></a>00169 
<a name="l00187"></a>00187         <a class="code" href="classOgre_1_1Controller.html">Controller&lt;Real&gt;</a>* createTextureWaveTransformer(<a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique, of a Material.">TextureUnitState</a>* layer, <a class="code" href="classOgre_1_1TextureUnitState.html#a942a1ce66d0909d29ed09c98e9e6d82d" title="Useful enumeration when dealing with procedural transforms.">TextureUnitState::TextureTransformType</a> ttype,
<a name="l00188"></a>00188             <a class="code" href="group__General.html#gabf2e0412a783a6f708ca1a58abb45c1b" title="Enumerates the wave types usable with the Ogre engine.">WaveformType</a> waveType, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> base = 0, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> frequency = 1, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> phase = 0, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> amplitude = 1);
<a name="l00189"></a>00189 
<a name="l00199"></a>00199         <a class="code" href="classOgre_1_1Controller.html">Controller&lt;Real&gt;</a>* createGpuProgramTimerParam(<a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a> params, <span class="keywordtype">size_t</span> paramIndex,
<a name="l00200"></a>00200             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> timeFactor = 1.0f);
<a name="l00201"></a>00201 
<a name="l00204"></a>00204         <span class="keywordtype">void</span> destroyController(<a class="code" href="classOgre_1_1Controller.html">Controller&lt;Real&gt;</a>* controller);
<a name="l00205"></a>00205 
<a name="l00210"></a>00210         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getTimeFactor(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00211"></a>00211 
<a name="l00220"></a>00220         <span class="keywordtype">void</span> setTimeFactor(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> tf);
<a name="l00221"></a>00221 
<a name="l00226"></a>00226         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getFrameDelay(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00227"></a>00227 
<a name="l00239"></a>00239         <span class="keywordtype">void</span> setFrameDelay(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fd);
<a name="l00240"></a>00240 
<a name="l00245"></a>00245         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getElapsedTime(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00246"></a>00246 
<a name="l00254"></a>00254         <span class="keywordtype">void</span> setElapsedTime(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> elapsedTime);
<a name="l00255"></a>00255 
<a name="l00271"></a>00271         <span class="keyword">static</span> <a class="code" href="classOgre_1_1ControllerManager.html" title="Class for managing Controller instances.">ControllerManager</a>&amp; getSingleton(<span class="keywordtype">void</span>);
<a name="l00287"></a>00287         <span class="keyword">static</span> <a class="code" href="classOgre_1_1ControllerManager.html" title="Class for managing Controller instances.">ControllerManager</a>* getSingletonPtr(<span class="keywordtype">void</span>);
<a name="l00288"></a>00288     };
<a name="l00289"></a>00289 
<a name="l00293"></a>00293 }
<a name="l00294"></a>00294 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:49
</p>
</body>
</html>
